# -*- coding:utf-8 -*-

# Copyright (C) 2020. Huawei Technologies Co., Ltd. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

"""Defined Configs."""

from vega.common import ConfigSerializable


class MFASCConfig(ConfigSerializable):
    """MF-ASC Config."""

    sample_size = 5000
    batch_size = 1000
    prior_rho = 1.0
    beta = 1.0
    max_budget = 1000
    hf_epochs = 20
    lf_epochs = 5
    fidelity_ratio = 2
    min_hf_sample_size = 3
    min_lf_sample_size = 10
    predictor_type = 'mfgpr'
    objective_keys = ["accuracy"]
